<ui:composition xmlns:g="http://www.ihe.net/gazelle" xmlns:rich="http://richfaces.org/rich"
                xmlns:ui="http://java.sun.com/jsf/facelets" xmlns:f="http://java.sun.com/jsf/core"
                xmlns:s="http://jboss.org/schema/seam/taglib" xmlns:h="http://java.sun.com/jsf/html"
                xmlns:a4j="http://richfaces.org/a4j"
                xmlns:c="http://java.sun.com/jstl/core" xmlns="http://www.w3.org/1999/xhtml">

    <h:outputScript library="javascripts" name="clipboard.min.js" target="head"/>
    <h:outputStylesheet library="stylesheets" name="clipboard.css" target="head"/>
    <c:set var="enableFilteringLinks" value="#{enableFilteringLinks == null ? true : enableFilteringLinks}"/>

    <a4j:queue requestDelay="300" ignoreDupResponses="true"/>
    <rich:dataTable id="messagesList" value="#{messagesList}" var="message"
                    rows="#{dataScrollerMemory.numberOfResultsPerPage}" rendered="#{messagesList.size()&gt;0}"
                    render="messageListHeadDS,messageListDS">

        <g:column rendered="#{applicationConfigurationManager.isAdminOnlyMode() and s:hasRole('admin_role')}">
            <s:span styleClass="gzl-icon-link" rendered="#{message.connection.privacyKey != null}"
                    title="This connection is shared"/>
            <s:span styleClass="gzl-icon-lock" rendered="#{message.connection.privacyKey == null}"
                    title="This connection is private"/>
        </g:column>

        <g:column sortBy="#{'connection.id'}">
            <ui:define name="header">
                <h:outputText value="#{messages['net.ihe.gazelle.proxy.ConnectionId']}"/>
            </ui:define>
            <h:commandLink
                    action="#{messagesBean.redirectToMessages(messagesBean.messageType,messagesBean.proxyPort,messagesBean.responderIP,messagesBean.responderPort,messagesBean.initiatorIP,messagesBean.initiatorPort,message.connection.id,messagesBean.dateFrom,messagesBean.dateTo,messagesBean.dicomAffectedSopClassUID,messagesBean.dicomCommandField,messagesBean.hl7MessageType,messagesBean.httpMessageType,messagesBean.shared,messagesBean.secured)}"
                    value="#{message.connection.id}" rendered="#{enableFilteringLinks}"/>
            <h:outputText value="#{message.connection.id}" rendered="#{not enableFilteringLinks}"/>
        </g:column>
        <g:column sortBy="#{'indexInt'}"
                  sortOrder="#{dataTableStateHolder.sortOrders['indexInt']}">
            <ui:define name="header">
                <h:outputText value="#{messages['net.ihe.gazelle.proxy.Index']}"/>
            </ui:define>
            <h:commandLink
                    action="#{messagesBean.redirectToMessages(messagesBean.messageType,messagesBean.proxyPort,messagesBean.responderIP,messagesBean.responderPort,messagesBean.initiatorIP,messagesBean.initiatorPort,message.connection.id,messagesBean.dateFrom,messagesBean.dateTo,messagesBean.dicomAffectedSopClassUID,messagesBean.dicomCommandField,messagesBean.hl7MessageType,messagesBean.httpMessageType,messagesBean.shared,messagesBean.secured)}"
                    value="#{messageBean.getMessageIndex(message)}" rendered="#{enableFilteringLinks}"/>
            <h:outputText value="#{messageBean.getMessageIndex(message)}" rendered="#{not enableFilteringLinks}"/>
        </g:column>
        <rich:column>
            <f:facet name="header">
                <h:outputText value="#{messages['net.ihe.gazelle.proxy.Type']}"/>
            </f:facet>
            <s:span styleClass="gzl-icon-arrow-right-request" title="Request"
                    rendered="#{message.proxySide.isRequest()}"/>
            <s:span styleClass="gzl-icon-arrow-left-response" title="Response"
                    rendered="#{not message.proxySide.isRequest()}"/>
        </rich:column>
        <g:column>
            <ui:define name="header">
                <h:outputText value="#{messages['net.ihe.gazelle.proxy.Details']}"/>
            </ui:define>
            <span class="gzl-never-wrap">
                <h:commandLink action="#{messagesBean.redirectToMessage(message)}"
                               value="#{messages['net.ihe.gazelle.proxy.Details']}" target="_blank"/>

                <button type="button" id="copy-button-#{message.id}" class="gzl-btn btn-sm"
                        data-clipboard-text="#{messagesBean.copyToClipboard(message)}"
                        title="Copy to clipboard">
                    <span class="fa fa-clipboard" style="margin-right:0;"/>
                </button>
                <script>
                    var clip = new Clipboard('#copy-button-#{message.id}');
                    clip.on('success', function (e) {
                        e.clearSelection();
                        e.trigger.setAttribute('class', 'gzl-btn tooltipped tooltipped-s');
                        e.trigger.setAttribute('aria-label', 'Copied!');
                    });
                    clip.on('error', function (e) {
                        e.clearSelection();
                        e.trigger.setAttribute('class', 'gzl-btn tooltipped tooltipped-s');
                        e.trigger.setAttribute('aria-label', 'Failed! It may be not supported by your browser');
                    });
                    jq162('#copy-button-#{message.id}').bind('mouseleave', function (e) {
                        e.currentTarget.setAttribute('class', 'gzl-btn btn-sm');
                        e.currentTarget.removeAttribute('aria-label');
                    });
                </script>

            </span>
        </g:column>
        <g:column sortBy="#{'dateReceived'}"
                  sortOrder="descending">
            <ui:define name="header">
                <h:outputText value="#{messages['net.ihe.gazelle.proxy.Date']}"/>
            </ui:define>
            <g:date value="#{message.dateReceived}"/>
        </g:column>
        <rich:column>
            <f:facet name="header">
                <h:outputText value="#{messages['net.ihe.gazelle.proxy.Times']})"/>
            </f:facet>
            <h:outputText value="#{messageBean.getNanos(message)}"/>
        </rich:column>
        <g:column width="15%" sortBy="#{'fromIP'}"
                  filterBy="#{'fromIP'}"
                  sortOrder="#{dataTableStateHolder.sortOrders['fromIP']}"
                  filterValue="#{dataTableStateHolder.columnFilterValues['fromIP']}">
            <ui:define name="header">
                <h:outputText value="#{messages['net.ihe.gazelle.proxy.From']}"/>
            </ui:define>
            <h:panelGroup rendered="#{enableFilteringLinks}">
                <h:commandLink
                        action="#{messagesBean.redirectToMessages(messagesBean.messageType,messagesBean.proxyPort,messagesBean.responderIP,messagesBean.responderPort,message.fromIP,messagesBean.initiatorPort,messagesBean.connectionId,messagesBean.dateFrom,messagesBean.dateTo,messagesBean.dicomAffectedSopClassUID,messagesBean.dicomCommandField,messagesBean.hl7MessageType,messagesBean.httpMessageType,messagesBean.shared,messagesBean.secured)}"
                        value="#{message.fromIP}"/>
                :
                <h:commandLink
                        action="#{messagesBean.redirectToMessages(messagesBean.messageType,messagesBean.proxyPort,messagesBean.responderIP,messagesBean.responderPort,messagesBean.initiatorIP,message.localPort,messagesBean.connectionId,messagesBean.dateFrom,messagesBean.dateTo,messagesBean.dicomAffectedSopClassUID,messagesBean.dicomCommandField,messagesBean.hl7MessageType,messagesBean.httpMessageType,messagesBean.shared,messagesBean.secured)}"
                        value="#{message.localPort}"/>
            </h:panelGroup>
            <h:panelGroup rendered="#{not enableFilteringLinks}">
                <h:outputText value="#{message.fromIP}"/>
                :
                <h:outputText value="#{message.localPort}"/>
            </h:panelGroup>
        </g:column>
        <g:column width="15%" filterEvent="onkeyup" sortBy="#{'toIP'}"
                  filterBy="#{'toIP'}"
                  sortOrder="#{dataTableStateHolder.sortOrders['toIP']}">
            <ui:define name="header">
                <h:outputText value="#{messages['net.ihe.gazelle.proxy.To']}"/>
            </ui:define>
            <h:panelGroup rendered="#{enableFilteringLinks}">
                <h:commandLink
                        action="#{messagesBean.redirectToMessages(messagesBean.messageType,messagesBean.proxyPort,message.toIP,messagesBean.responderPort,messagesBean.initiatorIP,messagesBean.initiatorPort,messagesBean.connectionId,messagesBean.dateFrom,messagesBean.dateTo,messagesBean.dicomAffectedSopClassUID,messagesBean.dicomCommandField,messagesBean.hl7MessageType,messagesBean.httpMessageType,messagesBean.shared,messagesBean.secured)}"
                        value="#{message.toIP}"/>
                :
                <h:commandLink
                        action="#{messagesBean.redirectToMessages(messagesBean.messageType,messagesBean.proxyPort,messagesBean.responderIP,message.remotePort,messagesBean.initiatorIP,messagesBean.initiatorPort,messagesBean.connectionId,messagesBean.dateFrom,messagesBean.dateTo,messagesBean.dicomAffectedSopClassUID,messagesBean.dicomCommandField,messagesBean.hl7MessageType,messagesBean.httpMessageType,messagesBean.shared,messagesBean.secured)}"
                        value="#{message.remotePort}"/>
            </h:panelGroup>
            <h:panelGroup rendered="#{not enableFilteringLinks}">
                <h:outputText value="#{message.toIP}"/>
                :
                <h:outputText value="#{message.remotePort}"/>
            </h:panelGroup>
        </g:column>
        <g:column width="10%" sortBy="#{'proxyPort'}"
                  sortOrder="#{dataTableStateHolder.sortOrders['proxyPort']}">
            <ui:define name="header">
                <h:outputText value="#{messages['net.ihe.gazelle.proxy.Proxy']}"/>
            </ui:define>
            <h:commandLink rendered="#{enableFilteringLinks}"
                           action="#{messagesBean.redirectToMessages(messagesBean.messageType,message.proxyPort,messagesBean.responderIP,messagesBean.responderPort,messagesBean.initiatorIP,messagesBean.initiatorPort,messagesBean.connectionId,messagesBean.dateFrom,messagesBean.dateTo,messagesBean.dicomAffectedSopClassUID,messagesBean.dicomCommandField,messagesBean.hl7MessageType,messagesBean.httpMessageType,messagesBean.shared,messagesBean.secured)}"
                           value="#{message.proxyPort}"/>
            <h:outputText value="#{message.proxyPort}" rendered="#{not enableFilteringLinks}"/>
        </g:column>

        <g:column width="8%">
            <ui:define name="header">
                <h:outputText value="#{messages['net.ihe.gazelle.proxy.Secured']}"/>
            </ui:define>
            <h:outputLink rendered="#{message.getConnection().isSecured()}"
                          class="gzl-icon-lock"
                          title="#{messages['net.ihe.gazelle.proxy.ClickToSeeDetails']}"
                          value="/proxy/admin/securedChannelConfiguration.seam"/>
        </g:column>

        <g:column width="20%">
            <ui:define name="header">
                <h:outputText value="#{messages['net.ihe.gazelle.proxy.Info']}"/>
            </ui:define>
            <h:outputText value="#{message.getLabel()}" escape="false"/>
        </g:column>

        <f:facet name="footer">
            <ui:include src="/util/datatableFooter.xhtml">
                <ui:param name="dataScrollerId" value="messageListDS"/>
                <ui:param name="dataTableId" value="messagesList"/>
            </ui:include>
        </f:facet>
    </rich:dataTable>
</ui:composition>
